{{- range $rootEnv, $environments := .Values.rootEnvironments }}
apiVersion: argoproj.io/v1alpha1
kind: Application
metadata:
  name: "{{ $rootEnv }}"
  namespace: argocd
  finalizers:
   - resources-finalizer.argocd.argoproj.io
  annotations:
    argocd.argoproj.io/sync-wave: "0"
spec:
  project: default
  syncPolicy:
    automated:
      #selfHeal: true
      prune: true
      allowEmpty: true
  destination:
    server: https://kubernetes.default.svc
    namespace: default
  source:
    path: deployment
    repoURL: {{ $.Values.global.source.repoURL }}
    targetRevision: {{ $.Values.global.source.targetRevision }}
    helm:
      valueFiles:
        - values.yaml
      parameters:
      - name: rootEnvironment
        value: {{ $rootEnv }}
      - name: global.source.repoURL
        value: {{ $.Values.global.source.repoURL }}
      {{- range $key, $val := $environments.environments }}
      - name: environments.{{ $key }}.basedOnEnv
        value: {{ $val.basedOnEnv }}
      {{- end }}
---        
{{- end }}